close all
clc

% INITIALIZATION:::

result_holder = [];


% INPUT VALUES:::

mu      =   3.986005e14;                        % WGS-84 value

s       =   input('Input perigee distance in m')% User Input for radial range of perigee
L_char  =   sqrt(mu*s);                         % L value required for circular orbit

p       =   input('Input the factor by which the L should be over L_char')
L       =   p*L_char;                           % Induced L value

% INITIAL VALUES:::

tht     =   0;                                  % Initial true anomaly

v_tht   =   L/s;                                % Initial Cross Radial Velocity
v_rad   =   0;                                  % Initial Radial Velocity

acc_cpl =   mu/s^2;                             % Inital gravitational Acceleration
acc_cfl =   L^2/s^3;                            % Initial Centrifugal Acceleration
acc_rad = acc_cfl - acc_cpl;                    % Initial Net Radial Acceleration
    
E       =   -0.5*(mu/L)^2;                      % Inital energy
d_char  =   L^2/mu;

t = 5;                                          % Time intervals

% UPDATING AT SUCCESSIVE TIME INTERVALS:::

for j=1:10000
    
    s       = s + v_rad*t+0.5*acc_rad*t^2;      % Updated range
    v_rad   = v_rad + acc_rad*t                 % Updated velocity
    
    tht     = tht + v_tht/s*t;                  % Updated true anomaly
    
    result_holder = [result_holder; tht  s  v_rad  v_tht];
                                                % Result storing
    
    
    v_tht   =   L/s;                            % Updated Cross Radial Velocity
    
    acc_cpl =   mu/s^2;                         % Updated gravitational Acceleration
    acc_cfl =   L^2/s^3;                        % Updated Centrifugal Acceleration
    
    acc_rad = acc_cfl - acc_cpl;                % Updated Net Radial Acceleration
    
end

% PLOTTING FIGURES:::

figure
polar(result_holder(:,1),result_holder(:,2))
title('RANGE WITH TRUE ANOMALY')
% 
figure
polar(result_holder(:,1),result_holder(:,3))
title('RADIAL VELOCITY WITH TRUE ANOMALY')
% 
figure
polar(result_holder(:,1),result_holder(:,4))
title('CROSS RADIAL VELOCITY WITH TRUE ANOMALY')

figure
polar(result_holder(:,1),result_holder(:,2).*result_holder(:,4))
title('ANGULAR MOMENTUM WITH TRUE ANOMALY')