function f = find_pos(tim,sat_info)

clc 
R_e=6378256.765;  %in km

R2D=180/pi; % radian to degree
D2R=pi/180; % degree to radian

for gg=1:size(sat_info,1)
    
    x_sat(gg)   =   sat_info(gg,1);
    y_sat(gg)   =   sat_info(gg,2);
    z_sat(gg)   =   sat_info(gg,3);
    rot(gg)     =   sat_info(gg,4);
    
    clc
    disp(['The position and range of satellite ' num2str(gg)])
    disp('.');
    disp(['x = ' num2str(x_sat(gg))]);
    disp(['y = ' num2str(y_sat(gg))]);
    disp(['z = ' num2str(z_sat(gg))]);
    disp(['R = ' num2str(rot(gg))]);
    disp('.')
    disp('.')
    pause(2)
    
end



disp('Approximate position assumed :')
lat_apx=25*D2R;
lon_apx=87*D2R;
x_apx=R_e*cos(lat_apx)*cos(lon_apx);
y_apx=R_e*cos(lat_apx)*sin(lon_apx);
z_apx=R_e*sin(lat_apx);
b_apx=10;

disp('.');
disp(['x_apx = ' num2str(x_apx)]);
disp(['y_apx = ' num2str(y_apx)]);
disp(['z_apx = ' num2str(z_apx)]);
disp(['b_apx = ' num2str(b_apx)]);
disp('.')
disp('.')
pause(2)



% disp('Directional cosines w.r.t. the approximate position of sat_#:')

G=[];
for gg=1:size(sat_info,1)
    
    G(gg,1)=-(x_sat(gg)-x_apx)/sqrt((x_sat(gg)-x_apx).^2+(y_sat(gg)-y_apx).^2+(z_sat(gg)-z_apx).^2);
    G(gg,2)=-(y_sat(gg)-y_apx)/sqrt((x_sat(gg)-x_apx).^2+(y_sat(gg)-y_apx).^2+(z_sat(gg)-z_apx).^2);
    G(gg,3)=-(z_sat(gg)-z_apx)/sqrt((x_sat(gg)-x_apx).^2+(y_sat(gg)-y_apx).^2+(z_sat(gg)-z_apx).^2);
    G(gg,4)=1;  
end

disp('Choosing the best set of Satellites .......')

DOP     =   [];
size(sat_info,1)
combos  =   combntns(1:size(sat_info,1),4)
size(combos)
pause

for tt=1:size(combos,1)
    
    sel     =   combos(tt,:);
    G_sel   =   G(sel,:);
    new_dop =   sqrt(sum(diag(G_sel'*inv(G_sel*G_sel'))));
    DOP     =   [DOP; new_dop];
    
end

size(DOP)
disp(['The minimum DOP obtained is ' num2str(min(DOP))]);
disp('.');
disp('.');
pause(1)

ss      =   find(DOP==min(DOP))

if(length(ss)>1)
    ss(2:end)=[];
end

sel     =   combos(ss,:);
x_sel   =   x_sat(sel);
y_sel   =   y_sat(sel);
z_sel   =   z_sat(sel);
rot_sel =   rot(sel);




iter = input('Input the numbers of Iteration you prefer to solve for position  :    ');

for itr=1:iter
        
    clc
    disp(['Iteration # ' num2str(itr)]);
    disp('.');
    
    disp('Approximated ranges to the selected 4 satellites are')
    
    rox_1=sqrt((x_sel(1)-x_apx).^2+(y_sel(1)-y_apx).^2+(z_sel(1)-z_apx).^2)+b_apx;
    rox_2=sqrt((x_sel(2)-x_apx).^2+(y_sel(2)-y_apx).^2+(z_sel(2)-z_apx).^2)+b_apx;
    rox_3=sqrt((x_sel(3)-x_apx).^2+(y_sel(3)-y_apx).^2+(z_sel(3)-z_apx).^2)+b_apx;
    rox_4=sqrt((x_sel(4)-x_apx).^2+(y_sel(4)-y_apx).^2+(z_sel(4)-z_apx).^2)+b_apx;
    
    disp('.');
    disp([  rox_1   rox_2   rox_3   rox_4]);
    disp('.');
    disp('.');
    pause(4)


    disp('Differences in Ranges are: dR')

    dr1=rot_sel(1)-rox_1;
    dr2=rot_sel(2)-rox_2;
    dr3=rot_sel(3)-rox_3;
    dr4=rot_sel(4)-rox_4;

    disp('.');
    disp([  dr1   dr2   dr3   dr4]);
    disp('.');
    disp('.');
    pause(4)
    

%     disp('Directional cosines w.r.t. the approximate position of sat_1:')
    G11=(x_sel(1)-x_apx)/sqrt((x_sel(1)-x_apx).^2+(y_sel(1)-y_apx).^2+(z_sel(1)-z_apx).^2);
    G12=(y_sel(1)-y_apx)/sqrt((x_sel(1)-x_apx).^2+(y_sel(1)-y_apx).^2+(z_sel(1)-z_apx).^2);
    G13=(z_sel(1)-z_apx)/sqrt((x_sel(1)-x_apx).^2+(y_sel(1)-y_apx).^2+(z_sel(1)-z_apx).^2);
    G14=1;

%     disp('Directional cosines w.r.t. the approximate position of sat_2:')
    G21=(x_sel(2)-x_apx)/sqrt((x_sel(2)-x_apx).^2+(y_sel(2)-y_apx).^2+(z_sel(2)-z_apx).^2);
    G22=(y_sel(2)-y_apx)/sqrt((x_sel(2)-x_apx).^2+(y_sel(2)-y_apx).^2+(z_sel(2)-z_apx).^2);
    G23=(z_sel(2)-z_apx)/sqrt((x_sel(2)-x_apx).^2+(y_sel(2)-y_apx).^2+(z_sel(2)-z_apx).^2);
    G24=1;

%     disp('Directional cosines w.r.t. the approximate position of sat_3:')
    G31=(x_sel(3)-x_apx)/sqrt((x_sel(3)-x_apx).^2+(y_sel(3)-y_apx).^2+(z_sel(3)-z_apx).^2);
    G32=(y_sel(3)-y_apx)/sqrt((x_sel(3)-x_apx).^2+(y_sel(3)-y_apx).^2+(z_sel(3)-z_apx).^2);
    G33=(z_sel(3)-z_apx)/sqrt((x_sel(3)-x_apx).^2+(y_sel(3)-y_apx).^2+(z_sel(3)-z_apx).^2);
    G34=1;

%     disp('Directional cosines w.r.t. the approximate position of sat_4:')
    G41=(x_sel(4)-x_apx)/sqrt((x_sel(4)-x_apx).^2+(y_sel(4)-y_apx).^2+(z_sel(4)-z_apx).^2);
    G42=(y_sel(4)-y_apx)/sqrt((x_sel(4)-x_apx).^2+(y_sel(4)-y_apx).^2+(z_sel(4)-z_apx).^2);
    G43=(z_sel(4)-z_apx)/sqrt((x_sel(4)-x_apx).^2+(y_sel(4)-y_apx).^2+(z_sel(4)-z_apx).^2);
    G44=1;

        
    

%     disp('Linearized observation matrix is :')
    M=[-G11 -G12 -G13 G14;...
       -G21 -G22 -G23 G24;...
       -G31 -G32 -G33 G34;...
       -G41 -G42 -G43 G44];
    
   
%     disp('The dR matrix is')
    drom=[dr1; dr2; dr3; dr4];
     
    
    disp('Linearized observation equation is : dR = G * dX ')
    disp('.');
    for bb=1:4
        disp([ num2str(drom(bb))  '   =   '     num2str(M(bb,1)) ' *dx +  '...
                                                num2str(M(bb,2)) ' *dy +  '...
                                                num2str(M(bb,3)) ' *dz +  '...
                                                num2str(M(bb,4)) ' *db '  ] );
    end
    disp('.')
    disp('.');
    pause(6)

    disp('Solution for dX is: GT * inv(GT*G)')
    disp('.');
    dXM=inv(M)*drom;
    disp(dXM);
    disp('.');
    disp('.');

    disp(['Solution after '  num2str(itr) ' iterations is:'])
    x_apx=x_apx+dXM(1);
    y_apx=y_apx+dXM(2);
    z_apx=z_apx+dXM(3);
    b_apx=b_apx+dXM(4);
    
    disp('.');
    disp([x_apx  y_apx  z_apx  b_apx]);
    disp('.');
    disp('.');
    pause(6)
    
end

clc
disp('Final solution of coordinates of user are:')
disp('-----------------------------------------------------------------');
disp('-----------------------------------------------------------------');
    
x_true=x_apx;
y_true=y_apx;
z_true=z_apx;
b_true=b_apx;
    
    
disp([x_true  y_true  z_true  b_true]);

disp('-----------------------------------------------------------------');
disp('-----------------------------------------------------------------');

disp('.');
disp('.');
disp('Press a key to continue');
pause