% This program finds the slant delay for the satellite visible for the
% longest time from the receiving station.


clear all;
close all

A       = load('obs.txt');

% Filter Parameters 
% ---------------------------------------------------

A(:,3:4) = [];


% Sort database  
% ---------------------------------------------------

count   = 0;
sat_n   = 0;
ss_max  = [];

for sn = 1:32
    
    ss = find(A(:,2)==sn);
    
    if length(ss)>count
        
        count = length(ss);
        sat_n = sn;
        ss_max = ss;
    end
    
end

A1  =   A(ss_max,:);
A1  =   sortrows(A1,1);
          
% ---------------------------------------------------
                       


% Estimate the Ionospheric parameters
% ---------------------------------------------------
        
f1        =   1575.42e6;
f2        =   1227.60e6;
        
TEC       =   inv((40.3/f1^2) - (40.3/f2^2)).*(A1(:,3)-A1(:,4))/1e16;
TEC       =   smooth(TEC);

% % Correct Ranges and add into sat_info database
% 
% R1        =   A1(:,3)- (40.3/(f1.^2))*TEC*1e16;
% R2        =   A1(:,4)- (40.3/(f2.^2))*TEC*1e16;
        
                        
% Plot
%---------------------------------------------------

figure
plot(A1(:,1)/3600,TEC);
xlabel('LOCAL TIME (HR)');
ylabel('SLANT TEC (TECU)');

% figure
% plot(A1(:,1)/3600,(A1(:,3))/1e3,'r')
% hold on
% plot(A1(:,1)/3600,R1/1e3,'b')
% xlabel('LOCAL TIME (HR)');
% ylabel('CORRECTED  RANGE (KM)');

% -------------------------------------------------- 
                      


