close all
clear all

R_e = 6400.00;                              % Earth Radius

lat = (22.2:0.1:45.3)'*pi/180;                  % Receiver latitude
lon = 88*pi/180;                            % Receiver longitude

xu =cos(lat).*cos(lon)*R_e;                 % Cartesians of receiver
yu =cos(lat).*sin(lon)*R_e;
zu =sin(lat);


R_sat   = 26500;                            % Satellite orbit radius

lat_sat = 32.2*pi/180;                      % Satellite latitude
lon_sat = 68*pi/180;                        % Satellite longitude

xs =cos(lat_sat).*cos(lon_sat)*R_sat;       % Satellite cartesians
ys =cos(lat_sat).*sin(lon_sat)*R_sat;
zs =sin(lat_sat)*R_sat;

dxs =20;                                    % Satellite deviations along
dys =15;                                    % cartesian axes
dzs =30;

dXs = [dxs  dys  dzs ] ;

R   = sqrt((xs - xu).^2+(ys - yu).^2+(zs - zu).^2);
                                            % Range from receiver
alf = ((xs - xu))./R;                       % alfa
bet = ((ys - yu))./R;                       % beta
gam = ((zs - zu))./R;                       % gamma


ddR =  [alf  bet   gam]*dXs';               % Effective range deviation

plot(ddR)
ylabel('EPHEMERIS  ERROR (KM)')
xlabel('DIFFERENT  RECEIVER  LOCATION')