close all
clear all

R_e = 6400.00;                              % Earth Radius

lat = (22.2)*pi/180;                        % Receiver latitude
lon = 88*pi/180;                            % Receiver longitude

xu =cos(lat).*cos(lon)*R_e;                 % Cartesians of receiver
yu =cos(lat).*sin(lon)*R_e;
zu =sin(lat);


R_sat   = 26500;                            % Satellite orbit radius

lat_sat = [32.2;  0.5; -15.3; 5.6]*pi/180;   % Satellite latitude
lon_sat = [68.0; 73.8;  91.4; 118.2]*pi/180; % Satellite longitude

xs =cos(lat_sat).*cos(lon_sat)*R_sat;       % Satellite cartesians
ys =cos(lat_sat).*sin(lon_sat)*R_sat;
zs =sin(lat_sat)*R_sat;


R   = sqrt((xs - xu).^2+(ys - yu).^2+(zs - zu).^2);
                                            % Range from receiver
alf = ((xs - xu))./R;                       % alfa
bet = ((ys - yu))./R;                       % beta
gam = ((zs - zu))./R;                       % gamma


G =  [alf  bet   gam  ones(4,1)];           % Geometric observation matrix

dR = [5.2; 4.1; 3.7; 9.2];
% dR = [25.2;  -4.1;  123.7;  -97.2];               % Total individual range error

dX = inv(G)*dR;                             % positional error

err = sqrt(dot(dX(1:3),dX(1:3)));                 % effective error

dX
err


cond(G)